from .c域 import 输出


def c_include(path: str):
    输出(f'#include "{path}"\n')


def c_pragma(v: str):
    输出(f'#pragma {v}\n')


def c_define(名字: str, 值: str):
    输出(f'#define {名字} {值}\n')


def c_undef(名字: str):
    输出(f'#undef {名字}\n')


def c_error(错误信息: str):
    输出(f'#error "{错误信息}"\n')


def c_line(行号: int, 文件名: str):
    输出(f'#line {行号} {文件名}\n')


class 如果定义了:
    def __init__(self, 宏定义名: str):
        self.宏定义名 = 宏定义名

    def __enter__(self, *args, **kwargs):
        输出(f"#ifdef {self.宏定义名}\n")
        return self

    def __exit__(self, *args, **kwargs):
        输出("#endif\n")

    def 否则(self):
        输出("#else\n")


class 如果没有定义:
    def __init__(self, 宏定义名: str):
        self.宏定义名 = 宏定义名

    def __enter__(self, *args, **kwargs):
        输出(f"#ifndef {self.宏定义名}\n")
        return self

    def __exit__(self, *args, **kwargs):
        输出("#endif\n")

    def 否则(self):
        输出("#else\n")


class 宏如果:
    def __init__(self, 条件: str):
        self.条件 = 条件

    def __enter__(self, *args, **kwargs):
        输出(f"#if {self.条件}\n")
        return self

    def __exit__(self, *args, **kwargs):
        输出("#endif\n")

    def 否则(self):
        输出("#else\n")

    def 否则如果(self, 条件: str):
        输出(f"#elif {条件}\n")
