import inspect


def 变量名(var):
    frame = inspect.currentframe()
    if frame is None:
        return 
    frame = frame.f_back
    if frame is None:
        return
    for name, value in frame.f_locals.items():
        if value is var:
            return name
    for name, value in frame.f_globals.items():
        if value is var:
            return name
    return None


def 上层变量名(var):
    frame = inspect.currentframe()
    if frame is None:
        return 
    frame = frame.f_back
    if frame is None:
        return
    counter = 0
    for name, value in frame.f_locals.items():
        if value is var:
            counter += 1
            if counter > 1:
                return name
    for name, value in frame.f_globals.items():
        if value is var:
            counter += 1
            if counter > 1:
                return name
    return None


def 十进制转换为其他进制(数值: int, 进制: int, digits="0123456789ABCDEF"):
    if 数值 == 0:
        return "0"
    result = ""
    is_negative = 数值 < 0
    数值 = abs(数值)
    while 数值 > 0:
        数值, remainder = divmod(数值, 进制)  # 除基取余
        result = digits[remainder] + result  # 余数映射字符
    return ("-" if is_negative else "") + result
